/* MA77RXT.Rexx - a Rexx/MQ/NT Example */

/* Define the Rexx/MQ interface to Rexx */

rcc = RXFuncadd('RXMQNINIT','RXMQN','RXMQNINIT')
say 'rc=' rcc

/* Initialise the interface */
RXMQNTRACE = ''

rcc= RXMQNINIT()
say 'rc=' rcc

/* Connect to Queue Manager - RAHN */

RXMQNTRACE = ''
rcc = RXMQNCONN("RAHN")
say 'RC=' rcc

/* Open Queue N1 for Inquire Access Only, tracing Object Descriptor accesses */

iod.on = 'N1'
iod.ot = MQOT_Q

RXMQNTRACE = 'BOD MOD'
rcc = RXMQNOPEN('iod.', mqoo_inquire, 'h1', 'ood.')
say 'RC=' rcc  'H=' h1

/* Open Queue P1 for Output and Browse Access, plus Attribute manipulation */

RXMQNTRACE = ''
rcc = RXMQNOPEN('P1', mqoo_inquire+mqoo_output+mqoo_browse+mqoo_set, 'h2', 'ood.')
say 'RC=' rcc  'H=' h2

/* Write a Persistent Message, within UOW, to Queue P1; trace everything */

RXMQNTRACE = 'PUT BMD MMD BPO BPO'
d.0      = 20
d.1      = time() '0123456789'
imd.PER  = MQPER_PERSISTENT
ipmo.opt = MQPMO_SYNCPOINT
rcc      = RXMQNPUT( h2,'d.','imd.','omd.','ipmo.','opmo.')
say 'RC=' rcc

/* Inquire upon the number of Messages now in Queue P1 */

RXMQNTRACE = ''
atrin = mqia_current_q_depth
atrou = ''
rcc   = RXMQNINQ(h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

/* Show the name of the Queue which is using handle 1*/

RXMQNTRACE = ''
atrin = mqca_q_name
atrou = ''
rcc   = RXMQNINQ(h1, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'
/* Toggle the GETtability of a Queue, providing a change each time */

RXMQNTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_INHIBITED
rcc   = RXMQNSET(h2, atrsn, atrsd)
say 'RC=' rcc

RXMQNTRACE = ''
atrin = mqia_inhibit_get ; atrou = ''
rcc   = RXMQNINQ(h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

RXMQNTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_ALLOWED
rcc   = RXMQNSET(h2, atrsn, atrsd)
say 'RC=' rcc

RXMQNTRACE = ''
atrin = MQIA_INHIBIT_GET ; atrou = ''
rcc = RXMQNINQ(h2, atrin, 'atrou' )
say 'RC=' rcc
say 'Atr' atrin 'Setting <'atrou'>'

/* Set the Trigger Data for a Queue ... */

RXMQNTRACE = ''
atrsn = MQCA_TRIGGER_DATA
atrsd = 'RAH Trigger Data'
rcc   = RXMQNSET(h2, atrsn, atrsd)
say 'RC=' rcc

/* ... and show that it's worked */

RXMQNTRACE = ''
atrin = mqca_trigger_data
atrou = ''
rcc = RXMQNINQ(h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

/* Syncpoint all accesses to the QM */

RXMQNTRACE = ''
rcc = RXMQNCMIT()
say 'RC=' rcc

/* Browse all messages on queue P1, tracing everything, and showing updates */

RXMQNTRACE = 'BGO MGO MMD BMD GET'
do i=1
   g.0      = 200
   g.1      = ''
   igmo.opt = MQGMO_WAIT+MQGMO_BROWSE_NEXT
   rcc = RXMQNGET( h2,'g.','igmd.','ogmd.','igmo.','ogmo.')
   say 'RC=' rcc
   say '...............' i 'data <'g.1'> length' g.0
   say 'ogmd.pd' ogmd.pd 'ogmo.rqn<'ogmo.rqn'>'
   if ( word(rcc,1) <> 0 ) then leave
   end

/* Rollback a Unit of Work (empty in this case) */
RXMQNTRACE = ''
rcc = RXMQNBACK()
say 'RC=' rcc

/* Stop access to a Queue */

RXMQNTRACE = ''
rcc = RXMQNCLOSE(h2, mqco_none)
say 'RC=' rcc

/* Re-open the P1 Queue for Browse only access */

RXMQNTRACE = ''
rcc = RXMQNOPEN('P1', mqoo_browse, 'h3', 'ood.')
say 'RC=' rcc  'H=' h3

/* Browse the Queue using the Extension function */
RXMQNTRACE = ''
do i=1
   g.0 = 200
   g.1 = ''
   rcc = RXMQNBROWSE( h3,'g.')
   say 'RC=' rcc
   say '@@@@@@@@@@@@@@@' i 'data <'g.1'> length' g.0
   if ( word(rcc,1) <> 0 ) then leave
   end

/* Show the last command used etc. */
say 'Last Message <'RXMQN.LASTMSG'> Last call 'RXMQN.LASTOP,
    ' which ended with RC('RXMQN.LASTRC') and MQCC('RXMQN.LASTCC')',
    ' MQRC('RXMQN.LASTAC')'


/* Issue a Bad command to show effect of -ve RC */
rcc = RXMQNOPEN()
say 'Last Message <'RXMQN.LASTMSG'> Last call 'RXMQN.LASTOP,
    ' which ended with RC('RXMQN.LASTRC') and MQCC('RXMQN.LASTCC')',
    ' MQRC('RXMQN.LASTAC')'

/* Stop access to the Queue */

RXMQNTRACE = ''
rcc = RXMQNCLOSE(h3, mqco_none)
say 'RC=' rcc

/* Disconnect from the QM (Closing h1 in the process) */

RXMQNTRACE = ''
rcc = RXMQNDISC()
say 'RC=' rcc

/* Remove the Interface functions from the Rexx Workspace ... */

RXMQNTRACE = 'TERM'
rcc = RXMQNTERM()
say 'RC=' rcc

/* ... but leave the MQ_ constants around */
say 'MQPER_PERSISTENT' MQPER_PERSISTENT 'RC(2048) is' RXMQN.RCMAP.2048
say 'MQGMO_CONVERT'    MQGMO_CONVERT    '(16384) '

/* End of MA77RXT.REXX exec */
